﻿var wzh = {
  dast: function(obj) {
    var element = document.querySelector(obj.title);
    if (element) {
      element.innerHTML = `<${obj.em}>${obj.text}</${obj.em}>`;
    }
    var data = { text: '' };
    var inputField = document.querySelector('#inputField');
    Object.defineProperty(data, 'text', {
      get: function() {
        return this._text;
      },
      set: function(value) {
        this._text = value;
        wzh.dast({
          title: "#outputField",
          text: value,
          em: "i"
        });
      }
    });
  },
 val: function(selector, elementType) {
    var element = document.querySelector(selector);
    if (element) {
      var tagName = element.tagName.toLowerCase();
      if (tagName === elementType) {
        if (elementType === "input" || elementType === "textarea") {
          return element.value;
        } else {
          return element.innerText;
        }
      } else {
        console.error("Element with selector", selector, "is not of type", elementType);
      }
    } else {
      console.error("No element found with selector", selector);
    }
    return null;
 },
  writ: function(data) {
    var newElement = document.createElement(data.em);
    newElement.innerText = data.text;
    newElement.classList.add(data.css);
    document.body.appendChild(newElement);
  },
  css: function(cssCode) {
    var styleElement = document.createElement('style');
    styleElement.innerText = cssCode;
    document.head.appendChild(styleElement);
  },
  alert: function(content, title, buttonText) {
    var popup = document.createElement('div');
    popup.style.position = 'fixed';
    popup.style.top = '50%';
    popup.style.left = '50%';
    popup.style.transform = 'translate(-50%, -50%)';
    popup.style.backgroundColor = '#3498db';
    popup.style.color = '#fff';
    popup.style.padding = '20px';
    popup.style.borderRadius = '5px';
    popup.style.boxShadow = '0 2px 10px rgba(0, 0, 0, 0.3)';
    popup.style.zIndex = '9999';
    var popupTitle = document.createElement('div');
    popupTitle.style.fontSize = '24px';
    popupTitle.style.marginBottom = '10px';
    popupTitle.innerText = title || '提示';
    popup.appendChild(popupTitle);
    var popupContent = document.createElement('div');
    popupContent.style.fontSize = '18px';
    popupContent.style.marginBottom = '20px';
    popupContent.innerText = content;
    popup.appendChild(popupContent);
    var popupButton = document.createElement('button');
    popupButton.style.backgroundColor = '#2980b9';
    popupButton.style.color = '#fff';
    popupButton.style.padding = '8px 16px';
    popupButton.style.border = 'none';
    popupButton.style.borderRadius = '3px';
    popupButton.style.cursor = 'pointer';
    popupButton.innerText = buttonText || '确定';
    popupButton.addEventListener('click', function() {
      document.body.removeChild(popup);
    });
    popup.appendChild(popupButton);
    document.body.appendChild(popup);
  },
  prompt: function(title, defaultValue, inputType, helpText, buttonText, okfun) {
    return new Promise(function(resolve, reject) {
      var popup = document.createElement('div');
      popup.style.position = 'fixed';
      popup.style.top = '50%';
      popup.style.left = '50%';
      popup.style.transform = 'translate(-50%, -50%)';
      popup.style.backgroundColor = '#3498db';
      popup.style.color = '#fff';
      popup.style.padding = '20px';
      popup.style.borderRadius = '5px';
      popup.style.boxShadow = '0 2px 10px rgba(0, 0, 0, 0.3)';
      popup.style.zIndex = '9999';

      var popupTitle = document.createElement('div');
      popupTitle.style.fontSize = '24px';
      popupTitle.style.marginBottom = '10px';
      popupTitle.innerText = title || '提示';
      popup.appendChild(popupTitle);

      var popupInput = document.createElement('input');
      popupInput.style.fontSize = '18px';
      popupInput.style.padding = '8px';
      popupInput.style.marginBottom = '20px';
      popupInput.style.width = '100%';
      popupInput.type = inputType || 'text';
      popupInput.value = defaultValue || '';
      popup.appendChild(popupInput);

      var popupHelpText = document.createElement('div');
      popupHelpText.style.fontSize = '14px';
      popupHelpText.innerText = helpText || '';
      popup.appendChild(popupHelpText);

      var popupButton = document.createElement('button');
      popupButton.style.backgroundColor = '#2980b9';
      popupButton.style.color = '#fff';
      popupButton.style.padding = '8px 16px';
      popupButton.style.border = 'none';
      popupButton.style.borderRadius = '3px';
      popupButton.style.cursor = 'pointer';
      popupButton.innerText = buttonText || '确定';
      popupButton.addEventListener('click', function() {
        document.body.removeChild(popup);
        return popupInput.value;
        okfun();
      });
      popup.appendChild(popupButton);

      document.body.appendChild(popup);
    });
  },
  ajax: function(options) {
    var xhr = new XMLHttpRequest();
    xhr.open('POST', options.url);
    xhr.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
    xhr.onreadystatechange = function() {
      if (xhr.readyState === XMLHttpRequest.DONE) {
        if (xhr.status === 200) {
          options.success(xhr.responseText);
        } else {
          options.error(xhr.statusText);
        }
      }
    };

    var formData = '';
    for (var i = 0; i < options.text.length; i++) {
      formData += encodeURIComponent(options.text[i]) + '=' + encodeURIComponent(options.text[++i]) + '&';
    }

    xhr.send(formData);
  },
  sin: function (x) {
  const EPSILON = 1e-15;
  x %= 2 * Math.PI;
  let term = x;
  let sum = x;

  for (let i = 3; Math.abs(term) >= EPSILON; i += 2) {
    term *= -x * x / (i * (i - 1));
    sum += term;
  }

  return sum;
  },
  cos: function (x) {
  const EPSILON = 1e-15;
  x %= 2 * Math.PI;
  let term = 1;
  let sum = 1;

  for (let i = 2; Math.abs(term) >= EPSILON; i += 2) {
    term *= -x * x / (i * (i - 1));
    sum += term;
  }

  return sum;
  },
  tan: function tan(x) {
  const sinVal = wzh.sin(x);
  const cosVal = wzh.cos(x);

  if (Math.abs(cosVal) < 1e-15) {
    throw new Error('tan(x) is undefined');
  }

  return sinVal / cosVal;
 },
  asin: function(x) {
    const EPSILON = 1e-15;

    if (x < -1 || x > 1) {
      throw new Error('wzh.asin(x) is undefined');
    }

    let term = x;
    let sum = x;

    for (let i = 3; Math.abs(term) >= EPSILON; i += 2) {
      term *= -(x * x) * (i - 2) / (i * (i - 1));
      sum += term;
    }

    return sum;
  },
  acos: function(x) {
    if (x < -1 || x > 1) {
      throw new Error('wzh.acos(x) is undefined');
    }

    return Math.PI / 2 - this.asin(x);
  },
  atan: function(x) {
    const EPSILON = 1e-15;
    let term = x;
    let sum = x;

    for (let i = 3; Math.abs(term) >= EPSILON; i += 2) {
      term *= -(x * x);
      sum += term / i;
    }

    return sum;
  },
  bufun: function (config) {
   var element = document.querySelector(config.id);
 
   if (element) {
     element.addEventListener('click', config.fun);
   }
  },
  if: function(ok, no, fun) {
    if (ok==no) {
      fun();
    } else {
    
    }
  },
  else: function(ok, no, fun) {
    if (ok==no){
    
    } else {
    fun();
    }
  },
  confirm: function (content, title, buttonText, cancelText, okCallback, cancelCallback) {
    var popup = document.createElement('div');
    popup.style.position = 'fixed';
    popup.style.top = '50%';
    popup.style.left = '50%';
    popup.style.transform = 'translate(-50%, -50%)';
    popup.style.backgroundColor = '#3498db';
    popup.style.color = '#fff';
    popup.style.padding = '20px';
    popup.style.borderRadius = '5px';
    popup.style.boxShadow = '0 2px 10px rgba(0, 0, 0, 0.3)';
    popup.style.zIndex = '9999';

    var popupTitle = document.createElement('div');
    popupTitle.style.fontSize = '24px';
    popupTitle.style.marginBottom = '10px';
    popupTitle.innerText = title || '提示';
    popup.appendChild(popupTitle);

    var popupContent = document.createElement('div');
    popupContent.style.fontSize = '18px';
    popupContent.style.marginBottom = '20px';
    popupContent.innerText = content;
    popup.appendChild(popupContent);

    var popupOkButton = document.createElement('button');
    popupOkButton.style.backgroundColor = '#2980b9';
    popupOkButton.style.color = '#fff';
    popupOkButton.style.padding = '8px 16px';
    popupOkButton.style.border = 'none';
    popupOkButton.style.borderRadius = '3px';
    popupOkButton.style.cursor = 'pointer';
    popupOkButton.innerText = buttonText || '确定';
    popupOkButton.addEventListener('click', function() {
        document.body.removeChild(popup);
        if (typeof okCallback === 'function') {
            okCallback();
        }
    });
    popup.appendChild(popupOkButton);

    var popupCancelButton = document.createElement('button');
    popupCancelButton.style.backgroundColor = '#2980b9';
    popupCancelButton.style.color = '#fff';
    popupCancelButton.style.padding = '8px 16px';
    popupCancelButton.style.border = 'none';
    popupCancelButton.style.borderRadius = '3px';
    popupCancelButton.style.cursor = 'pointer';
    popupCancelButton.innerText = cancelText || '取消';
    popupCancelButton.addEventListener('click', function() {
        document.body.removeChild(popup);
        if (typeof cancelCallback === 'function') {
            cancelCallback();
        }
    });
    popup.appendChild(popupCancelButton);

    document.body.appendChild(popup);
 },
 adot: function(options) {
  var popup = document.createElement('div');
  popup.style.position = 'fixed';
  popup.style.top = '50%';
  popup.style.left = '50%';
  popup.style.transform = 'translate(-50%, -50%)';
  popup.style.backgroundColor = '#3498db';
  popup.style.color = '#fff';
  popup.style.padding = '20px';
  popup.style.borderRadius = '5px';
  popup.style.boxShadow = '0 2px 10px rgba(0, 0, 0, 0.3)';
  popup.style.zIndex = '9999';

  var popupTitle = document.createElement('div');
  popupTitle.style.fontSize = '24px';
  popupTitle.style.marginBottom = '10px';
  popupTitle.innerText = options.title || '提示';
  popup.appendChild(popupTitle);

  var popupContent = document.createElement('div');
  popupContent.style.fontSize = '18px';
  popupContent.style.marginBottom = '20px';
  popupContent.innerText = options.text;
  popup.appendChild(popupContent);

  for (var i = 0; i < options.button.length; i++) {
    var button = document.createElement('button');
    button.style.backgroundColor = '#2980b9';
    button.style.color = '#fff';
    button.style.padding = '8px 16px';
    button.style.border = 'none';
    button.style.borderRadius = '3px';
    button.style.cursor = 'pointer';
    button.innerText = options.button[i];
    (function(index) {
      button.addEventListener('click', function() {
        if (options.buttonCallback && typeof options.buttonCallback === 'function') {
          options.buttonCallback(index);
        }
        document.body.removeChild(popup);
      });
    })(i);

    popup.appendChild(button);
  }

  document.body.appendChild(popup);
 },
  commands: {},

  getpass: function(options) {
    var keyword = options.pass;
    var action = options.fun;

    this.commands[keyword] = action;
  },
  funget: function(commandText) {
    var command = this.commands[commandText.trim()];

    if (command) {
      command();
    }
  },
  var: function(variable, value) {
    if (typeof window[variable] !== 'undefined') {
        window[variable] = value;
    } else {
        window[variable] = value;
    }
   },
  blog: function(str){
  const blueStyle = 'color: darkblue; background-color: lightblue; text-shadow: 1px 1px 2px #000;';
  console.log('%c' + str, blueStyle);
  },
  glog: function(str){
  const greenStyle = 'color: darkgreen; background-color: lightgreen; text-shadow: 1px 1px 2px #000;';
  console.log('%c' + str, blueStyle);
  },
  json: function (obj) {
  if (obj.type === "ok") {
    var parsedJson = JSON.parse(obj.json);
    return parsedJson;
  }
  return true;
},
soman: function (config) {
  var element = document.createElement(config.em);
  if (config.id) {
    element.setAttribute('id', config.id);
  }
  if (config.src) {
    element.setAttribute('src', config.src);
  }
  if (config.href) {
    var linkElement = document.getElementById(config.id);
    if (linkElement) {
      linkElement.setAttribute('href', config.href);
    }
  }
  if (config.value) {
    element.value = config.value;
  }
  if (config.onclick) {
    element.onclick = function() {
      eval(config.onclick);
    };
  }
  if (typeof config.dom === 'function') {
    config.dom(element);
  }
  document.body.appendChild(element);
},
for: function(num, fun){
 for (let i = 0; i < num; i++) {
  fun();
 }
},
  VNode: function(tag, data, children, text, element) {
    this.tag = tag;
    this.data = data;
    this.children = children;
    this.text = text;
    this.element = element;
    this.parent = null;
    this.elm = null;
  },
  createElement: function(tag, data, children) {
    let childrenArray = [];
    for (let i = 2; i < arguments.length; i++) {
      if (Array.isArray(arguments[i])) {
        childrenArray = childrenArray.concat(arguments[i]);
      } else {
        childrenArray.push(arguments[i]);
      }
    }
    return new wzh.VNode(tag, data, childrenArray);
  },
  createTextNode: function(text) {
    return new wzh.VNode(undefined, undefined, undefined, String(text));
  },
  createEmptyNode: function() {
    return new wzh.VNode(undefined, undefined, undefined, '');
  },
  isSameNodeType: function(node1, node2) {
    return node1.tag === node2.tag && node1.key === node2.key;
  },
  patch: function(parent, oldNode, newNode) {
    if (!oldNode) {
      wzh.addNode(parent, null, newNode, 0, newNode.children.length - 1);
    } else if (!newNode) {
      wzh.removeNode(parent, oldNode, 0, oldNode.children.length - 1);
    } else if (wzh.isSameNodeType(oldNode, newNode)) {
      wzh.updateNode(oldNode, newNode);
      for (let i = 0; i < newNode.children.length || i < oldNode.children.length; i++) {
        wzh.patch(oldNode.element, oldNode.children[i], newNode.children[i]);
      }
    } else {
      wzh.replaceNode(parent, oldNode, newNode);
    }
  },
  addNode: function(parent, before, node, startIdx, endIdx) {
    for (let i = startIdx; i <= endIdx; i++) {
      wzh.insertElement(parent, node.children[i].element, before);
    }
  },
  removeNode: function(parent, node, startIdx, endIdx) {
    for (let i = startIdx; i <= endIdx; i++) {
      wzh.removeElement(parent, node.children[i].element);
    }
  },
  updateNode: function(oldNode, newNode) {
    if (!newNode.element) {
      newNode.element = oldNode.element;
    }
    if (!newNode.text) {
      wzh.updateAttributes(oldNode, newNode);
      wzh.updateChildren(oldNode, newNode);
    } else if (newNode.text !== oldNode.text) {
      newNode.element.textContent = newNode.text;
    }
  },
  replaceNode: function(parent, oldNode, newNode) {
    wzh.removeNode(parent, oldNode, 0, oldNode.children.length - 1);
    wzh.addNode(parent, null, newNode, 0, newNode.children.length - 1);
  },
  insertElement: function(parent, el, before) {
    if (parent) {
      parent.insertBefore(el, before);
    }
  },
  removeElement: function(parent, el) {
    if (parent) {
      parent.removeChild(el);
    }
  },
  updateAttributes: function(oldNode, newNode) {
    const oldAttrs = oldNode.data || {};
    const newAttrs = newNode.data || {};
    const oldAttrKeys = Object.keys(oldAttrs);
    const newAttrKeys = Object.keys(newAttrs);
    for (let i = 0; i < oldAttrKeys.length; i++) {
      const attr = oldAttrKeys[i];
      if (!(attr in newAttrs)) {
        oldNode.element.removeAttribute(attr);
      }
    }
    for (let i = 0; i < newAttrKeys.length; i++) {
      const attr = newAttrKeys[i];
      const value = newAttrs[attr];
      if (oldAttrs[attr] !== value) {
        oldNode.element.setAttribute(attr, value);
      }
    }
  },
  updateChildren: function(oldNode, newNode) {
    const oldChildren = oldNode.children;
    const newChildren = newNode.children;

    const oldStartIdx = 0;
    const oldEndIdx = oldChildren.length - 1;
    let oldStartNode = oldChildren[oldStartIdx];
    let oldEndNode = oldChildren[oldEndIdx];

    const newStartIdx = 0;
    const newEndIdx = newChildren.length - 1;
    let newStartNode = newChildren[newStartIdx];
    let newEndNode = newChildren[newEndIdx];

    while (oldStartIdx <= oldEndIdx && newStartIdx <= newEndIdx) {
      if (!oldStartNode) {
        oldStartNode = oldChildren[++oldStartIdx];
      } else if (!oldEndNode) {
        oldEndNode = oldChildren[--oldEndIdx];
      } else if (wzh.isSameNodeType(oldStartNode, newStartNode)) {
        wzh.patch(oldStartNode.element, oldStartNode, newStartNode);
        oldStartNode = oldChildren[++oldStartIdx];
        newStartNode = newChildren[++newStartIdx];
      } else if (wzh.isSameNodeType(oldEndNode, newEndNode)) {
        wzh.patch(oldEndNode.element, oldEndNode, newEndNode);
        oldEndNode = oldChildren[--oldEndIdx];
        newEndNode = newChildren[--newEndIdx];
      } else if (wzh.isSameNodeType(oldStartNode, newEndNode)) {
        wzh.patch(oldStartNode.element, oldStartNode, newEndNode);
        wzh.insertElement(
          oldNode.element,
          oldStartNode.element,
          oldEndNode.element.nextSibling
        );
        oldStartNode = oldChildren[++oldStartIdx];
        newEndNode = newChildren[--newEndIdx];
      } else if (wzh.isSameNodeType(oldEndNode, newStartNode)) {
        wzh.patch(oldEndNode.element, oldEndNode, newStartNode);
        wzh.insertElement(oldNode.element, oldEndNode.element, oldStartNode.element);
        oldEndNode = oldChildren[--oldEndIdx];
        newStartNode = newChildren[++newStartIdx];
      } else {
        const idxInOld = wzh.findIndexInOldNode(oldChildren, newStartNode);
        if (idxInOld >= 0) {
          const vnodeToMove = oldChildren[idxInOld];
          wzh.patch(vnodeToMove.element, vnodeToMove, newStartNode);
          oldChildren[idxInOld] = undefined;
          wzh.insertElement(oldNode.element, vnodeToMove.element, oldStartNode.element);
        } else {
          wzh.addNode(oldNode.element, oldStartNode.element, newStartNode, 0, 0);
        }
        newStartNode = newChildren[++newStartIdx];
      }
    }

    if (oldStartIdx > oldEndIdx) {
      wzh.addNode(
        oldNode.element,
        newChildren[newEndIdx + 1] ? newChildren[newEndIdx + 1].element : null,
        newChildren,
        newStartIdx,
        newEndIdx
      );
    } else if (newStartIdx > newEndIdx) {
      wzh.removeNode(oldNode.element, oldChildren, oldStartIdx, oldEndIdx);
    }
  },
  findIndexInOldNode: function(c, node) {
    for (let i = 0; i < c.length; i++) {
      const el = c[i];
      if (el && wzh.isSameNodeType(el, node)) {
        return i;
      }
    }
    return -1;
  },

//模块元素
  modules: {},
  mod: function(moduleName) {
    return this.modules[moduleName];
  },
  wzhcry: function() {
    this.md5 = function (s) {
  function toHexString(byteArray) {
    return Array.from(byteArray, function(byte) {
      return ('0' + (byte & 0xFF).toString(16)).slice(-2);
    }).join('');
  }
  function utf8Encode(str) {
    return unescape(encodeURIComponent(str));
  }
  function md5cycle(x, k) {
    let a = x[0],
        b = x[1],
        c = x[2],
        d = x[3];
    a = ff(a, b, c, d, k[0], 7, -680876936);
    d = ff(d, a, b, c, k[1], 12, -389564586);
    c = ff(c, d, a, b, k[2], 17, 606105819);
    b = ff(b, c, d, a, k[3], 22, -1044525330);
    a = ff(a, b, c, d, k[4], 7, -176418897);
    d = ff(d, a, b, c, k[5], 12, 1200080426);
    c = ff(c, d, a, b, k[6], 17, -1473231341);
    b = ff(b, c, d, a, k[7], 22, -45705983);
    a = ff(a, b, c, d, k[8], 7, 1770035416);
    d = ff(d, a, b, c, k[9], 12, -1958414417);
    c = ff(c, d, a, b, k[10], 17, -42063);
    b = ff(b, c, d, a, k[11], 22, -1990404162);
    a = ff(a, b, c, d, k[12], 7, 1804603682);
    d = ff(d, a, b, c, k[13], 12, -40341101);
    c = ff(c, d, a, b, k[14], 17, -1502002290);
    b = ff(b, c, d, a, k[15], 22, 1236535329);
    a = gg(a, b, c, d, k[1], 5, -165796510);
    d = gg(d, a, b, c, k[6], 9, -1069501632);
    c = gg(c, d, a, b, k[11], 14, 643717713);
    b = gg(b, c, d, a, k[0], 20, -373897302);
    a = gg(a, b, c, d, k[5], 5, -701558691);
    d = gg(d, a, b, c, k[10], 9, 38016083);
    c = gg(c, d, a, b, k[15], 14, -660478335);
    b = gg(b, c, d, a, k[4], 20, -405537848);
    a = gg(a, b, c, d, k[9], 5, 568446438);
    d = gg(d, a, b, c, k[14], 9, -1019803690);
    c = gg(c, d, a, b, k[3], 14, -187363961);
    b = gg(b, c, d, a, k[8], 20, 1163531501);
    a = gg(a, b, c, d, k[13], 5, -1444681467);
    d = gg(d, a, b, c, k[2], 9, -51403784);
    c = gg(c, d, a, b, k[7], 14, 1735328473);
    b = gg(b, c, d, a, k[12], 20, -1926607734);
    a = hh(a, b, c, d, k[5], 4, -378558);
    d = hh(d, a, b, c, k[8], 11, -2022574463);
    c = hh(c, d, a, b, k[11], 16, 1839030562);
    b = hh(b, c, d, a, k[14], 23, -35309556);
    a = hh(a, b, c, d, k[1], 4, -1530992060);
    d = hh(d, a, b, c, k[4], 11, 1272893353);
    c = hh(c, d, a, b, k[7], 16, -155497632);
    b = hh(b, c, d, a, k[10], 23, -1094730640);
    a = hh(a, b, c, d, k[13], 4, 681279174);
    d = hh(d, a, b, c, k[0], 11, -358537222);
    c = hh(c, d, a, b, k[3], 16, -722521979);
    b = hh(b, c, d, a, k[6], 23, 76029189);
    a = hh(a, b, c, d, k[9], 4, -640364487);
    d = hh(d, a, b, c, k[12], 11, -421815835);
    c = hh(c, d, a, b, k[15], 16, 530742520);
    b = hh(b, c, d, a, k[2], 23, -995338651);
    a = ii(a, b, c, d, k[0], 6, -198630844);
    d = ii(d, a, b, c, k[7], 10, 1126891415);
    c = ii(c, d, a, b, k[14], 15, -1416354905);
    b = ii(b, c, d, a, k[5], 21, -57434055);
    a = ii(a, b, c, d, k[12], 6, 1700485571);
    d = ii(d, a, b, c, k[3], 10, -1894986606);
    c = ii(c, d, a, b, k[10], 15, -1051523);
    b = ii(b, c, d, a, k[1], 21, -2054922799);
    a = ii(a, b, c, d, k[8], 6, 1873313359);
    d = ii(d, a, b, c, k[15], 10, -30611744);
    c = ii(c, d, a, b, k[6], 15, -1560198380);
    b = ii(b, c, d, a, k[13], 21, 1309151649);
    a = ii(a, b, c, d, k[4], 6, -145523070);
    d = ii(d, a, b, c, k[11], 10, -1120210379);
    c = ii(c, d, a, b, k[2], 15, 718787259);
    b = ii(b, c, d, a, k[9], 21, -343485551);
    x[0] = add32(a, x[0]);
    x[1] = add32(b, x[1]);
    x[2] = add32(c, x[2]);
    x[3] = add32(d, x[3]);
  }
  function cmn(q, a, b, x, s, t) {
    a = add32(add32(a, q), add32(x, t));
    return add32((a << s) | (a >>> (32 - s)), b);
  }
  function ff(a, b, c, d, x, s, t) {
    return cmn((b & c) | ((~b) & d), a, b, x, s, t);
  }
  function gg(a, b, c, d, x, s, t) {
    return cmn((b & d) | (c & (~d)), a, b, x, s, t);
  }
  function hh(a, b, c, d, x, s, t) {
    return cmn(b ^ c ^ d, a, b, x, s, t);
  }
  function ii(a, b, c, d, x, s, t) {
    return cmn(c ^ (b | (~d)), a, b, x, s, t);
  }
  function md51(s) {
    let txt = '';
    let n = s.length,
        state = [1732584193, -271733879, -1732584194, 271733878];
    for (let i = 64; i <= s.length; i += 64) {
      md5cycle(state, md5blk(utf8Encode(s.substring(i-64, i))));
    }
    s = s.substring(i-64);
    let tail = Array(n*8).fill(0);
    for (let i = 0; i < s.length; i++) {
      tail[i>>2] |= s.charCodeAt(i) << ((i%4) << 3);
    }
    tail[i>>2] |= 0x80 << ((i%4) << 3);
    if (i > 55) {
      md5cycle(state, tail);
      for (let i = 0; i < 16; i++) {
        tail[i] = 0;
      }
    }
    tail[14] = n*8;
    md5cycle(state, tail);

    return state;
  }
  function md5blk(s) {
    const md5blks = [];
    for (let i = 0; i < 64; i += 4) {
      md5blks[i >> 2] = s.charCodeAt(i) + (s.charCodeAt(i + 1) << 8) + (s.charCodeAt(i + 2) << 16) + (s.charCodeAt(i + 3) << 24);
    }
    return md5blks;
  }
  function add32(a, b) {
    return (a + b) & 0xFFFFFFFF;
  }
  return toHexString(md51(s));
};
    this.sha1 = function(str) {
  function rotateLeft(n, s) {
    return (n << s) | (n >>> (32 - s));
  }
  function cvtHex(val) {
    var hex = "";
    var mask = 15;
    for (var i = 7; i >= 0; i--) {
      hex += hexChars[(val >>> (i * 4)) & mask];
    }
    return hex;
  }
  function utf8Encode(str) {
    str = str.replace(/\r\n/g, "\n");
    var utf8Text = "";
    for (var n = 0; n < str.length; n++) {
      var charCode = str.charCodeAt(n);
      if (charCode < 128) {
        utf8Text += String.fromCharCode(charCode);
      } else if ((charCode > 127) && (charCode < 2048)) {
        utf8Text += String.fromCharCode((charCode >> 6) | 192);
        utf8Text += String.fromCharCode((charCode & 63) | 128);
      } else {
        utf8Text += String.fromCharCode((charCode >> 12) | 224);
        utf8Text += String.fromCharCode(((charCode >> 6) & 63) | 128);
        utf8Text += String.fromCharCode((charCode & 63) | 128);
      }
    }
    return utf8Text;
  }
  var hexChars = "0123456789abcdef";
  var blockstart;
  var i, j;
  var W = new Array(80);
  var H0 = 0x67452301;
  var H1 = 0xEFCDAB89;
  var H2 = 0x98BADCFE;
  var H3 = 0x10325476;
  var H4 = 0xC3D2E1F0;
  var A, B, C, D, E;
  var temp;
  str = utf8Encode(str);
  var strLen = str.length;
  var wordArray = [];
  for (i = 0; i < strLen - 3; i += 4) {
    j = str.charCodeAt(i) << 24 | str.charCodeAt(i + 1) << 16 |
      str.charCodeAt(i + 2) << 8 | str.charCodeAt(i + 3);
    wordArray.push(j);
  }
  switch (strLen % 4) {
    case 0:
      i = 0x080000000;
      break;
    case 1:
      i = str.charCodeAt(strLen - 1) << 24 | 0x0800000;
      break;
    case 2:
      i = str.charCodeAt(strLen - 2) << 24 | str.charCodeAt(strLen - 1) << 16 | 0x08000;
      break;
    case 3:
      i = str.charCodeAt(strLen - 3) << 24 | str.charCodeAt(strLen - 2) << 16 | str.charCodeAt(strLen - 1) << 8 | 0x80;
      break;
  }
  wordArray.push(i);
  while ((wordArray.length % 16) != 14) wordArray.push(0);
  wordArray.push(strLen >>> 29);
  wordArray.push((strLen << 3) & 0x0ffffffff);
  for (blockstart = 0; blockstart < wordArray.length; blockstart += 16) {
    for (i = 0; i < 16; i++) W[i] = wordArray[blockstart + i];
    for (i = 16; i <= 79; i++) {
      W[i] = rotateLeft(W[i - 3] ^ W[i - 8] ^ W[i - 14] ^ W[i - 16], 1);
    }
    A = H0;
    B = H1;
    C = H2;
    D = H3;
    E = H4;
    for (i = 0; i <= 19; i++) {
      temp = (rotateLeft(A, 5) + ((B & C) | (~B & D)) + E + W[i] + 0x5A827999) & 0x0ffffffff;
      E = D;
      D = C;
      C = rotateLeft(B, 30);
      B = A;
      A = temp;
    }
    for (i = 20; i <= 39; i++) {
      temp = (rotateLeft(A, 5) + (B ^ C ^ D) + E + W[i] + 0x6ED9EBA1) & 0x0ffffffff;
      E = D;
      D = C;
      C = rotateLeft(B, 30);
      B = A;
      A = temp;
    }
    for (i = 40; i <= 59; i++) {
      temp = (rotateLeft(A, 5) + ((B & C) | (B & D) | (C & D)) + E + W[i] + 0x8F1BBCDC) & 0x0ffffffff;
      E = D;
      D = C;
      C = rotateLeft(B, 30);
      B = A;
      A = temp;
    }
    for (i = 60; i <= 79; i++) {
      temp = (rotateLeft(A, 5) + (B ^ C ^ D) + E + W[i] + 0xCA62C1D6) & 0x0ffffffff;
      E = D;
      D = C;
      C = rotateLeft(B, 30);
      B = A;
      A = temp;
    }
    H0 = (H0 + A) & 0x0ffffffff;
    H1 = (H1 + B) & 0x0ffffffff;
    H2 = (H2 + C) & 0x0ffffffff;
    H3 = (H3 + D) & 0x0ffffffff;
    H4 = (H4 + E) & 0x0ffffffff;
  }
  var sha1Hash = cvtHex(H0) + cvtHex(H1) + cvtHex(H2) + cvtHex(H3) + cvtHex(H4);
  return sha1Hash;
};
    this.sha256 = function(str) {
  function rightRotate(n, x) {
    return (x >>> n) | (x << (32 - n));
  }
  function toHex(num) {
    var hexChars = '0123456789abcdef';
    var result = '';
    for (var i = 0; i < 8; i++) {
      result += hexChars.charAt((num >>> (28 - i * 4)) & 0x0f);
    }
    return result;
  }
  function utf8Encode(str) {
    str = str.replace(/\r\n/g, '\n');
    var utf8Text = '';
    for (var n = 0; n < str.length; n++) {
      var charCode = str.charCodeAt(n);
      if (charCode < 128) {
        utf8Text += String.fromCharCode(charCode);
      } else if ((charCode > 127) && (charCode < 2048)) {
        utf8Text += String.fromCharCode((charCode >> 6) | 192);
        utf8Text += String.fromCharCode((charCode & 63) | 128);
      } else {
        utf8Text += String.fromCharCode((charCode >> 12) | 224);
        utf8Text += String.fromCharCode(((charCode >> 6) & 63) | 128);
        utf8Text += String.fromCharCode((charCode & 63) | 128);
      }
    }
    return utf8Text;
  }
  var K = [
    0x428a2f98, 0x71374491, 0xb5c0fbcf, 0xe9b5dba5,
    0x3956c25b, 0x59f111f1, 0x923f82a4, 0xab1c5ed5,
    0xd807aa98, 0x12835b01, 0x243185be, 0x550c7dc3,
    0x72be5d74, 0x80deb1fe, 0x9bdc06a7, 0xc19bf174,
    0xe49b69c1, 0xefbe4786, 0x0fc19dc6, 0x240ca1cc,
    0x2de92c6f, 0x4a7484aa, 0x5cb0a9dc, 0x76f988da,
    0x983e5152, 0xa831c66d, 0xb00327c8, 0xbf597fc7,
    0xc6e00bf3, 0xd5a79147, 0x06ca6351, 0x14292967,
    0x27b70a85, 0x2e1b2138, 0x4d2c6dfc, 0x53380d13,
    0x650a7354, 0x766a0abb, 0x81c2c92e, 0x92722c85,
    0xa2bfe8a1, 0xa81a664b, 0xc24b8b70, 0xc76c51a3,
    0xd192e819, 0xd6990624, 0xf40e3585, 0x106aa070,
    0x19a4c116, 0x1e376c08, 0x2748774c, 0x34b0bcb5,
    0x391c0cb3, 0x4ed8aa4a, 0x5b9cca4f, 0x682e6ff3,
    0x748f82ee, 0x78a5636f, 0x84c87814, 0x8cc70208,
    0x90befffa, 0xa4506ceb, 0xbef9a3f7, 0xc67178f2
  ];
  str = utf8Encode(str);
  var strLen = str.length * 8;
  var paddingLen = (strLen + 64 >>> 9 << 4) + 15;
  var padding = new Array(paddingLen + 1);
  padding[0] = 0x80;
  for (var i = 1; i < paddingLen; i++) {
    padding[i] = 0;
  }
  padding[paddingLen - 1] = strLen;
  var chunks = [];
  for (var i = 0; i < padding.length; i += 16) {
    var chunk = padding.slice(i, i + 16);
    chunks.push(chunk);
  }
  var H = [
    0x6a09e667, 0xbb67ae85, 0x3c6ef372, 0xa54ff53a,
    0x510e527f, 0x9b05688c, 0x1f83d9ab, 0x5be0cd19
  ];
  for (var i = 0; i < chunks.length; i++) {
    var chunk = chunks[i];
    var W = chunk.slice();
    for (var t = 16; t < 64; t++) {
      var s0 = rightRotate(7, W[t - 15]);
      var s1 = rightRotate(18, W[t - 2]);
      W[t] = (W[t - 16] + s0 + W[t - 7] + s1) & 0xffffffff;
    }
    var a = H[0];
    var b = H[1];
    var c = H[2];
    var d = H[3];
    var e = H[4];
    var f = H[5];
    var g = H[6];
    var h = H[7];
    for (var t = 0; t < 64; t++) {
      var S1 = rightRotate(6, e) ^ rightRotate(11, e) ^ rightRotate(25, e);
      var ch = (e & f) ^ (~e & g);
      var temp1 = (h + S1 + ch + K[t] + W[t]) & 0xffffffff;
      var S0 = rightRotate(2, a) ^ rightRotate(13, a) ^ rightRotate(22, a);
      var maj = (a & b) ^ (a & c) ^ (b & c);
      var temp2 = (S0 + maj) & 0xffffffff;
      h = g;
      g = f;
      f = e;
      e = (d + temp1) & 0xffffffff;
      d = c;
      c = b;
      b = a;
      a = (temp1 + temp2) & 0xffffffff;
    }
    H[0] = (H[0] + a) & 0xffffffff;
    H[1] = (H[1] + b) & 0xffffffff;
    H[2] = (H[2] + c) & 0xffffffff;
    H[3] = (H[3] + d) & 0xffffffff;
    H[4] = (H[4] + e) & 0xffffffff;
    H[5] = (H[5] + f) & 0xffffffff;
    H[6] = (H[6] + g) & 0xffffffff;
    H[7] = (H[7] + h) & 0xffffffff;
  }
  var hash = '';
  for (var i = 0; i < H.length; i++) {
    hash += toHex(H[i]);
  }
  return hash;
};
    this.sha384 = function(str) {
  function rightRotate(n, x) {
    return (x >>> n) | (x << (32 - n));
  }
  function toHex(num) {
    var hexChars = '0123456789abcdef';
    var result = '';
    for (var i = 0; i < 16; i++) {
      result += hexChars.charAt((num >>> (28 - i * 4)) & 0x0f);
    }
    return result;
  }
  function utf8Encode(str) {
    str = str.replace(/\r\n/g, '\n');
    var utf8Text = '';
    for (var n = 0; n < str.length; n++) {
      var charCode = str.charCodeAt(n);
      if (charCode < 128) {
        utf8Text += String.fromCharCode(charCode);
      } else if ((charCode > 127) && (charCode < 2048)) {
        utf8Text += String.fromCharCode((charCode >> 6) | 192);
        utf8Text += String.fromCharCode((charCode & 63) | 128);
      } else {
        utf8Text += String.fromCharCode((charCode >> 12) | 224);
        utf8Text += String.fromCharCode(((charCode >> 6) & 63) | 128);
        utf8Text += String.fromCharCode((charCode & 63) | 128);
      }
    }
    return utf8Text;
  }
  var K = [
    0xcbbb9d5d, 0xc1059ed8, 0x629a292a, 0x367cd507,
    0x9159015a, 0x3070dd17, 0x152fecd8, 0xf70e5939,
    0x67332667, 0xffc00b31, 0x8eb44a87, 0x68581511,
    0x64f98fa7, 0xbefa4fa4, 0x8771f681, 0xb2b45a92,
    0x6a09e667, 0x84caa73b, 0x3c6ef372, 0xfe94f82b,
    0xa54ff53a, 0x5f1d36f1, 0x510e527f, 0xade682d1,
    0x9b05688c, 0x2b3e6c1f, 0x1f83d9ab, 0xfb41bd6b,
    0x5be0cd19, 0x137e2179, 0x41d4bb63, 0x5c748dcb,
    0x2826a2f9, 0x6ea6e483, 0x4db47560, 0x766a0abb,
    0x6582390c, 0x3badd62b, 0x0842fcbc, 0x8ebb0f40,
    0x32caab7b, 0x94f5d27a, 0x359ab641, 0xc37bf51f,
    0xa90c5b70, 0x05fbdcaf, 0xbe0e1777, 0x1f86cde1,
    0x0fe948d1, 0x5381d0a6, 0xd5a79147, 0x930aa725,
    0x32bbd1b8, 0x48a82d68, 0x6f9c11b3, 0x1e376c08,
    0x762e503e, 0x2cb17ed1, 0x37ebfad8, 0xa676f2d9,
    0x14ea562e, 0x3e169769, 0x44a54bca, 0x2b3c99c7,
    0x4ede1997, 0x72eacf48, 0xdf13d38d, 0x0d95748f
  ];
  str = utf8Encode(str);
  var strLen = str.length * 8;
  var paddingLen = (strLen + 128 >>> 10 << 6) + 127;
  var padding = new Array(paddingLen + 1);
  padding[0] = 0x80;
  for (var i = 1; i < paddingLen; i++) {
    padding[i] = 0;
  }
  padding[paddingLen - 8] = strLen >>> 29 & 0xff;
  padding[paddingLen - 7] = strLen >>> 21 & 0xff;
  padding[paddingLen - 6] = strLen >>> 13 & 0xff;
  padding[paddingLen - 5] = strLen >>> 5 & 0xff;
  padding[paddingLen - 4] = strLen << 3 & 0xff;
  var chunks = [];
  for (var i = 0; i < padding.length; i += 16) {
    var chunk = padding.slice(i, i + 16);
    chunks.push(chunk);
  }
  var H = [
    0xcbbb9d5d, 0x629a292a, 0x9159015a, 0x152fecd8,
    0x67332667, 0xffc00b31, 0x8eb44a87, 0x64f98fa7
  ];
  for (var i = 0; i < chunks.length; i++) {
    var chunk = chunks[i];
    var W = chunk.slice();
    for (var t = 16; t < 80; t++) {
      var s0 = rightRotate(1, W[t - 2]) ^ rightRotate(8, W[t - 2]) ^ (W[t - 2] >>> 3);
      var s1 = rightRotate(19, W[t - 15]) ^ rightRotate(61, W[t - 15]) ^ (W[t - 15] >>> 6);
      W[t] = (W[t - 16] + s0 + W[t - 7] + s1) & 0xffffffff;
    }
    var a = H[0];
    var b = H[1];
    var c = H[2];
    var d = H[3];
    var e = H[4];
    var f = H[5];
    var g = H[6];
    var h = H[7];
    for (var t = 0; t < 80; t++) {
      var S1 = rightRotate(14, e) ^ rightRotate(18, e) ^ rightRotate(41, e);
      var ch = (e & f) ^ (~e & g);
      var temp1 = (h + S1 + ch + K[t] + W[t]) & 0xffffffff;
      var S0 = rightRotate(28, a) ^ rightRotate(34, a) ^ rightRotate(39, a);
      var maj = (a & b) ^ (a & c) ^ (b & c);
      var temp2 = (S0 + maj) & 0xffffffff;
      h = g;
      g = f;
      f = e;
      e = (d + temp1) & 0xffffffff;
      d = c;
      c = b;
      b = a;
      a = (temp1 + temp2) & 0xffffffff;
    }
    H[0] = (H[0] + a) & 0xffffffff;
    H[1] = (H[1] + b) & 0xffffffff;
    H[2] = (H[2] + c) & 0xffffffff;
    H[3] = (H[3] + d) & 0xffffffff;
    H[4] = (H[4] + e) & 0xffffffff;
    H[5] = (H[5] + f) & 0xffffffff;
    H[6] = (H[6] + g) & 0xffffffff;
    H[7] = (H[7] + h) & 0xffffffff;
  }
  var hash = '';
  for (var i = 0; i < H.length; i++) {
    hash += toHex(H[i]);
  }
  return hash;
};
    this.sha224 = function sha224(){
  function rightRotate(n, x) {
    return (x >>> n) | (x << (32 - n));
  }
  function toHex(num) {
    var hexChars = '0123456789abcdef';
    var result = '';
    for (var i = 0; i < 8; i++) {
      result += hexChars.charAt((num >>> (28 - i * 4)) & 0x0f);
    }
    return result;
  }
  function utf8Encode(str) {
    str = str.replace(/\r\n/g, '\n');
    var utf8Text = '';
    for (var n = 0; n < str.length; n++) {
      var charCode = str.charCodeAt(n);
      if (charCode < 128) {
        utf8Text += String.fromCharCode(charCode);
      } else if ((charCode > 127) && (charCode < 2048)) {
        utf8Text += String.fromCharCode((charCode >> 6) | 192);
        utf8Text += String.fromCharCode((charCode & 63) | 128);
      } else {
        utf8Text += String.fromCharCode((charCode >> 12) | 224);
        utf8Text += String.fromCharCode(((charCode >> 6) & 63) | 128);
        utf8Text += String.fromCharCode((charCode & 63) | 128);
      }
    }
    return utf8Text;
  }
  function padding(str) {
    var paddingLen = (str.length + 9 + 64) >>> 6 << 4;
    var padding = new Array(paddingLen + 1);
    padding[0] = 0x80;
    for (var i = 1; i < paddingLen; i++) {
      padding[i] = 0;
    }
    var strLen = str.length * 8;
    padding[paddingLen - 8] = strLen >>> 24 & 0xff;
    padding[paddingLen - 7] = strLen >>> 16 & 0xff;
    padding[paddingLen - 6] = strLen >>> 8 & 0xff;
    padding[paddingLen - 5] = strLen & 0xff;
    for (var i = 0; i < str.length; i++) {
      padding[i] = str.charCodeAt(i);
    }
    return padding;
  }
  var K = [
    0xc1059ed8, 0x367cd507, 0x3070dd17, 0xf70e5939,
    0xffc00b31, 0x68581511, 0x64f98fa7, 0xbefa4fa4
  ];
  var H = [
    0xc1059ed8, 0x367cd507, 0x3070dd17, 0xf70e5939,
    0xffc00b31, 0x68581511, 0x64f98fa7, 0xbefa4fa4
  ];
  str = utf8Encode(str);
  var chunks = padding(str);
  for (var i = 0; i < chunks.length; i += 16) {
    var w = new Array(64);
    for (var t = 0; t < 16; t++) {
      w[t] = (chunks[i + t] << 24) | (chunks[i + t] << 16) | (chunks[i + t] << 8) | chunks[i + t];
    }
    for (var t = 16; t < 64; t++) {
      var s0 = rightRotate(7, w[t - 15]) ^ rightRotate(18, w[t - 15]) ^ (w[t - 15] >>> 3);
      var s1 = rightRotate(17, w[t - 2]) ^ rightRotate(19, w[t - 2]) ^ (w[t - 2] >>> 10);
      w[t] = (w[t - 16] + s0 + w[t - 7] + s1) & 0xffffffff;
    }
    var a = H[0];
    var b = H[1];
    var c = H[2];
    var d = H[3];
    var e = H[4];
    var f = H[5];
    var g = H[6];
    var h = H[7];
    for (var t = 0; t < 64; t++) {
      var S1 = rightRotate(6, e) ^ rightRotate(11, e) ^ rightRotate(25, e);
      var ch = (e & f) ^ (~e & g);
      var temp1 = (h + S1 + ch + K[t] + w[t]) & 0xffffffff;
      var S0 = rightRotate(2, a) ^ rightRotate(13, a) ^ rightRotate(22, a);
      var maj = (a & b) ^ (a & c) ^ (b & c);
      var temp2 = (S0 + maj) & 0xffffffff;
      h = g;
      g = f;
      f = e;
      e = (d + temp1) & 0xffffffff;
      d = c;
      c = b;
      b = a;
      a = (temp1 + temp2) & 0xffffffff;
    }
    H[0] = (H[0] + a) & 0xffffffff;
    H[1] = (H[1] + b) & 0xffffffff;
    H[2] = (H[2] + c) & 0xffffffff;
    H[3] = (H[3] + d) & 0xffffffff;
    H[4] = (H[4] + e) & 0xffffffff;
    H[5] = (H[5] + f) & 0xffffffff;
    H[6] = (H[6] + g) & 0xffffffff;
    H[7] = (H[7] + h) & 0xffffffff;
  }
  var hash = '';
  for (var i = 0; i < H.length; i++) {
    hash += toHex(H[i]);
  }
  return hash;
};
    this.sha512 = function(input) {
  function rightRotate(n, x) {
    return (x >>> n) | (x << (64 - n));
  }
  function toHexString(num) {
    var hexString = "";
    for (var i = 0; i < 8; i++) {
      var hex = (num >>> (56 - i * 8)) & 0xff;
      hexString += (hex < 16 ? "0" : "") + hex.toString(16);
    }
    return hexString;
  }
  function padding(message) {
    var paddingBytes = [];
    for (var i = 0; i < message.length; i++) {
      paddingBytes.push(message.charCodeAt(i));
    }
    var bitLength = message.length * 8;
    paddingBytes.push(0x80);
    var paddingSize = 128 - (paddingBytes.length % 128);
    if (paddingSize < 16) {
      paddingSize += 128;
    }
    for (var i = 0; i < paddingSize - 16; i++) {
      paddingBytes.push(0x00);
    }
    var lengthBytes = [];
    for (var i = 7; i >= 0; i--) {
      lengthBytes.push((bitLength >>> (i * 8)) & 0xff);
    }
    paddingBytes = paddingBytes.concat(lengthBytes);
    
    return paddingBytes;
  }
  function blocks(input) {
    var blocks = [];
    var paddingBytes = padding(input);
    for (var i = 0; i < paddingBytes.length / 128; i++) {
      var block = new Array(80);
      for (var j = 0; j < 16; j++) {
        block[j] = (paddingBytes[i * 128 + j * 8] << 56) |
                   (paddingBytes[i * 128 + j * 8 + 1] << 48) |
                   (paddingBytes[i * 128 + j * 8 + 2] << 40) |
                   (paddingBytes[i * 128 + j * 8 + 3] << 32) |
                   (paddingBytes[i * 128 + j * 8 + 4] << 24) |
                   (paddingBytes[i * 128 + j * 8 + 5] << 16) |
                   (paddingBytes[i * 128 + j * 8 + 6] << 8) |
                   (paddingBytes[i * 128 + j * 8 + 7]);
      }
      blocks.push(block);
    }
    return blocks;
  }
  function computeHashBlock(block, hash) {
    var w = new Array(80);
    for (var i = 16; i < 80; i++) {
      var s0 = rightRotate(1, w[i - 15]);
      var s1 = rightRotate(61, w[i - 2]);
      w[i] = (w[i - 16] + s0 + w[i - 7] + s1) | 0;
    }
    var a = hash[0];
    var b = hash[1];
    var c = hash[2];
    var d = hash[3];
    var e = hash[4];
    var f = hash[5];
    var g = hash[6];
    var h = hash[7];
    for (var i = 0; i < 80; i++) {
      var S1 = rightRotate(14, e) ^ rightRotate(18, e) ^ rightRotate(41, e);
      var ch = (e & f) ^ (~e & g);
      var temp1 = (h + S1 + ch + K[i] + block[i]) | 0;
      var S0 = rightRotate(28, a) ^ rightRotate(34, a) ^ rightRotate(39, a);
      var maj = (a & b) ^ (a & c) ^ (b & c);
      var temp2 = (S0 + maj) | 0;
      h = g;
      g = f;
      f = e;
      e = (d + temp1) | 0;
      d = c;
      c = b;
      b = a;
      a = (temp1 + temp2) | 0;
    }
    hash[0] = (hash[0] + a) | 0;
    hash[1] = (hash[1] + b) | 0;
    hash[2] = (hash[2] + c) | 0;
    hash[3] = (hash[3] + d) | 0;
    hash[4] = (hash[4] + e) | 0;
    hash[5] = (hash[5] + f) | 0;
    hash[6] = (hash[6] + g) | 0;
    hash[7] = (hash[7] + h) | 0;
  }
  var state = [
    0x6a09e667f3bcc908, 0xbb67ae8584caa73b, 0x3c6ef372fe94f82b, 0xa54ff53a5f1d36f1,
    0x510e527fade682d1, 0x9b05688c2b3e6c1f, 0x1f83d9abfb41bd6b, 0x5be0cd19137e2179
  ];
var K = [
  0x428a2f98d728ae22, 0x7137449123ef65cd, 0xb5c0fbcfec4d3b2f, 0xe9b5dba58189dbbc,
  0x3956c25bf348b538, 0x59f111f1b605d019, 0x923f82a4af194f9b, 0xab1c5ed5da6d8118,
  0xd807aa98a3030242, 0x12835b0145706fbe, 0x243185be4ee4b28c, 0x550c7dc3d5ffb4e2,
  0x72be5d74f27b896f, 0x80deb1fe3b1696b1, 0x9bdc06a725c71235, 0xc19bf174cf692694,
  0xe49b69c19ef14ad2, 0xefbe4786384f25e3, 0x0fc19dc68b8cd5b5, 0x240ca1cc77ac9c65,
  0x2de92c6f592b0275, 0x4a7484aa6ea6e483, 0x5cb0a9dcbd41fbd4, 0x76f988da831153b5,
  0x983e5152ee66dfab, 0xa831c66d2db43210, 0xb00327c898fb213f, 0xbf597fc7beef0ee4,
  0xc6e00bf33da88fc2, 0xd5a79147930aa725, 0x06ca6351e003826f, 0x142929670a0e6e70,
  0x27b70a8546d22ffc, 0x2e1b21385c26c926, 0x4d2c6dfc5ac42aed, 0x53380d139d95b3df,
  0x650a73548baf63de, 0x766a0abb3c77b2a8, 0x81c2c92e47edaee6, 0x92722c851482353b,
  0xa2bfe8a14cf10364, 0xa81a664bbc423001, 0xc24b8b70d0f89791, 0xc76c51a30654be30,
  0xd192e819d6ef5218, 0xd69906245565a910, 0xf40e35855771202a, 0x106aa07032bbd1b8,
  0x19a4c116b8d2d0c8, 0x1e376c085141ab53, 0x2748774cdf8eeb99, 0x34b0bcb5e19b48a8,
  0x391c0cb3c5c95a63, 0x4ed8aa4ae3418acb, 0x5b9cca4f7763e373, 0x682e6ff3d6b2b8a3,
  0x748f82ee5defb2fc, 0x78a5636f43172f60, 0x84c87814a1f0ab72, 0x8cc702081a6439ec,
  0x90befffa23631e28, 0xa4506cebde82bde9, 0xbef9a3f7b2c67915, 0xc67178f2e372532b,
  0xca273eceea26619c, 0xd186b8c721c0c207, 0xeada7dd6cde0eb1e, 0xf57d4f7fee6ed178
];
  var messageBlocks = blocks(input);
  for (var i = 0; i < messageBlocks.length; i++) {
    computeHashBlock(messageBlocks[i], state);
  }
  var hash = "";
  for (var i = 0; i < state.length; i++) {
    hash += toHexString(state[i]);
  }
  return hash;
};
}
};
wzh.modules["wzhcry"] = new wzh.wzhcry();